package com.zcloud.mapper.datasource.system;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.entity.system.Department;

import java.util.List;
import java.util.Map;

/**
 * 说明： 组织机构接Mapper
 * 创建人：luoxiaobao
 * 官网：
 */
public interface DepartmentMapper{

	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public void save(PageData pd)throws Exception;

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	public void delete(PageData pd)throws Exception;

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	public void edit(PageData pd)throws Exception;

	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> datalistPage(Page page)throws Exception;

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findById(PageData pd)throws Exception;
	/**通过名称获取数据
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> findByName(PageData pd)throws Exception;

	/**通过编码获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findByBianma(PageData pd)throws Exception;

	/**
	 * 通过ID获取其子级列表
	 * @param parentId
	 * @return
	 * @throws Exception
	 */
	public List<Department> listSubDepartmentByParentId(String parentId) throws Exception;

	/**
	 * 通过ID获取其子级列表
	 * @param parentId
	 * @return
	 * @throws Exception
	 */
	public List<Department> listSubDepByParentId(PageData pd) throws Exception;

	/**
	 * 获取所有数据并填充每条数据的子级列表(递归处理)
	 * @param MENU_ID
	 * @return
	 * @throws Exception
	 */
	public List<Department> listAllDepartment(String parentId) throws Exception;

	/**
	 * 获取所有数据并填充每条数据的子级列表(递归处理)下拉ztree用
	 * @param MENU_ID
	 * @return
	 * @throws Exception
	 */
	public List<PageData> listAllDepartmentToSelect(String parentId, List<PageData> zdepartmentPdList) throws Exception;

	/**获取某个部门所有下级部门ID(返回拼接字符串 in的形式)
	 * @param DEPARTMENT_ID
	 * @return
	 * @throws Exception
	 */
	public String getDEPARTMENT_IDS(String DEPARTMENT_ID) throws Exception;

	/**通过条件获取全部
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> listAll(PageData pd)throws Exception;

	public PageData findByCorpId(PageData pd);
	/**列表 关联 部门级别名称
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> forLevelNamedatalistPage(Page page)throws Exception;

	/**
	 * 查询公司部门总数
	 * @param pd
	 * @return
	 */
	public int getDepCount(PageData pd);

	/**
	 * 查询公司检查过清单的部门总数
	 * @param pd
	 * @return
	 */
	public int getWorkedDepCount(PageData pd);

    List<PageData> findBySubId(PageData pd);

	List<PageData> listDept(PageData pd);

	List<PageData> Dept(Page pd);

	List<PageData> getSonIdsByParid(PageData pd);

	List<PageData> listTreeManageAndCorp2(PageData pd);

	List<PageData> listTreeManageAndCorpNum(PageData pd);

	/**
	 * 向下递归查询企业部门
	 * @param pd
	 * @return
	 */
	List<PageData> listTreeCorpDept(PageData pd);

	List<PageData> listForDoor(PageData pd);

	List<PageData> islistAll(PageData pd);

	public List<Department> listDepartAllByCorpinfoId(String CORPINFO_ID) throws Exception;

	/**
	 * 向下递归查询企业部门（只查监管端部门表）
	 * @param pd
	 * @return
	 * @throws Exception
	 */
	List<PageData> listTreeManageAndCorp1(PageData pd);

	/**
	 * pc新增需求，重点工程中添加处罚人功能所用的 根据企业ID查询部门的sql
	 * @param pd
	 * @return
	 */
	List<PageData> listTreeManageAndCorpForPcPunishThePerson(PageData pd);

	List<PageData> saftmanagelist(PageData pd);

	List<PageData> saftpersonlist(PageData pd);

	List<Map<String, Object>> getDeptAllByCorp(PageData pd);
}

